<template>
    <div class="left__top--two animated fadeInLeft">
        <div class="one__topSvg">
            <svg class="noActive">
                <use xlink:href="/img/sprite.svg#increase-size-option"/>
            </svg>
            <svg class="noActive" :class="activeTypeClass('bar')" @click="selectType('bar')">
                <use xlink:href="/img/sprite.svg#stats"/>
            </svg>
            <svg class="noActive" :class="activeTypeClass('pie')" @click="selectType('pie')">
                <use xlink:href="/img/sprite.svg#circular-business-graphic"/>
            </svg>
        </div>
        <p class="text-tarif"><span>{{ $t('dashboard.top_payments_first') }}</span>{{ $t('dashboard.top_payments_second') }}</p>
        <top-pie-chart :chart_data="pieData" v-if="type === 'pie'"></top-pie-chart>
        <top-bar-chart :chart_data="barData" v-else-if="type === 'bar'"></top-bar-chart>
    </div>
</template>

<script>
	import _ from 'lodash';
    import TopPieChart from "../charts/TopPieChart";
    import {mapGetters} from "vuex";
    import TopBarChart from "../charts/TopBarChart";
	export default {
		name: "TopPaymentsChart",
		props: ['payments'],
		data(){
            return {
                type: 'pie'
            }
		},
        computed: {
            ...mapGetters([
                'payment_systems'
            ]),
            pieData(){
                if(this.payments){
                    let chart_data = _.map(this.payments, (value, key) => {
                        if(key){
                            return {
                                value: value,
                                name: key,
                            }
                        }else{
                            return {
                                value: value,
                                name: '',
                                itemStyle: {
                                    color: '#f9f9f9'
                                }
                            }
                        }
                    })
                    return _.orderBy(chart_data, 'value', 'desc');
                }
                return [
                    {
                        value: 0,
                        name: '',
                        itemStyle: {
                            color: '#f9f9f9'
                        }
                    }
                ]
            },
            barData(){
                if(this.payments){
                    let chart_data = _.map(this.payments, (value, key) => {
                        if(key){
                            let ps = _.find(this.payment_systems, {name: key});
                            return [ps.code, value];
                        }
                        return ['Others', value];
                    })
                    return _.orderBy(chart_data, 1, 'desc');
                }
                return [
                    ['', 0]
                ]
            }
        },
        methods: {
            activeTypeClass(type){
                return {
                    'yesActive': this.type === type
                }
            },
            selectType(type){
                this.type = type;
            }
        },
        components: {
            TopPieChart,
            TopBarChart
        }
	}
</script>
